diff --git a/hubs/tests/vcr-request-data/hubs.tests.test_widget_validators.ValidatorsTest.test_pagure_repo b/hubs/tests/vcr-request-data/hubs.tests.test_widget_validators.ValidatorsTest.test_pagure_repo
new file mode 100644
index 0000000..03a168e
--- /dev/null
+++ b/hubs/tests/vcr-request-data/hubs.tests.test_widget_validators.ValidatorsTest.test_pagure_repo
@@ -0,0 +1,351 @@
+interactions:
+- request:
+    body: null
+    headers:
+      Accept: ['*/*']
+      Accept-Encoding: ['gzip, deflate']
+      Connection: [keep-alive]
+      User-Agent: [python-requests/2.13.0]
+    method: GET
+    uri: https://pagure.io/fedora-hubs
+  response:
+    body: {string: "<!DOCTYPE html>\n<html lang='en'>\n<head>\n    <meta http-equiv=\"\
+        Content-Type\" content=\"text/html; charset=UTF-8\"/>\n    <title>Overview\
+        \ - fedora-hubs - Pagure</title>\n    <link rel=\"shortcut icon\" type=\"\
+        image/vnd.microsoft.icon\"\n        href=\"/static/favicon.ico\"/>\n    <link\
+        \ href=\"https://apps.fedoraproject.org/global/fedora-bootstrap-1.0.1/fedora-bootstrap.css\"\
+        \n        type=\"text/css\" rel=\"stylesheet\" />\n    <link href=\"/static/pagure.css\"\
+        \n        type=\"text/css\" rel=\"stylesheet\" />\n    <link href=\"/static/open-iconic/css/open-iconic.min.css\"\
+        \n        type=\"text/css\" rel=\"stylesheet\" />\n    <link href=\"/static/fonts/fonts.css\"\
+        \n        rel=\"stylesheet\" type=\"text/css\" />\n    <link href=\"/static/hack_fonts/css/hack-extended.min.css\"\
+        \n        type=\"text/css\" rel=\"stylesheet\" />\n    <meta name=\"go-import\"\
+        \ content=\"pagure.io/fedora-hubs git https://pagure.io/fedora-hubs.git\"\
+        >\n  </head>\n  <body id=\"home\">\n  <!-- start masthead -->\n    <div class=\"\
+        masthead\">\n      <div class=\"container\">\n        <div class=\"row\">\n\
+        \          <div class=\"col-sm-3\">\n            <a href=\"/\">\n        \
+        \      <img height=40px src=\"/static/pagure-logo.png\"\n                alt=\"\
+        pagure Logo\" id=\"pagureLogo\"/>\n            </a>\n          </div>\n  \
+        \        <div class=\"col-sm-9\">\n            <div class=\"row\">\n\n  <nav\
+        \ class=\"navbar navbar-light p-t-0 p-b-0\">\n      <div class=\"container\"\
+        >\n        <ul class=\"nav navbar-nav nav-underline pull-xs-right\">\n   \
+        \           <li class=\"nav-item p-l-1\">\n                <a class=\"nav-link\
+        \ btn btn-primary\" href=\"/login/?next=https://pagure.io/fedora-hubs\">Log\
+        \ In</a>\n              </li>\n        </ul>\n      </div>\n    </nav>\n\n\
+        \            </div>\n          </div>\n        </div>\n      </div>\n    </div><!--\
+        \ close masthead-->\n\n    <div class=\"bodycontent p-b-3\">\n\n\n<div class=\"\
+        repo-header p-t-1\">\n  <div class=\"container\">\n    <header>\n      <h2\
+        \ class=\"repo-name m-b-0\">\n        <a href=\"/fedora-hubs\">\nfedora-hubs</a>\n\
+        \        </h2>\n        <div class=\"projectinfo m-t-1 m-b-1\">\nFedora Hubs\
+        \ &nbsp;| &nbsp;<a class=\"inline\" href=\"https://hubs-dev.fedorainfracloud.org/\"\
+        >https://hubs-dev.fedorainfracloud.org/</a>        </div>\n\n    </header>\n\
+        \    <ul class=\"nav nav-tabs nav-small\">\n      <li class=\"nav-item\">\n\
+        \        <a class=\"nav-link active\" href=\"/fedora-hubs\">\n           \
+        \ <span class=\"oi hidden-md-up\" data-glyph=\"home\"></span>\n          \
+        \  <span class=\"hidden-sm-down\">Overview</span>\n        </a>\n      </li>\n\
+        \        <li class=\"nav-item\" >\n          <a  class=\"nav-link\" href=\"\
+        /docs/fedora-hubs/\">\n              <span class=\"oi hidden-md-up\" data-glyph=\"\
+        book\"></span>\n              <span class=\"hidden-sm-down\">Docs</span>\n\
+        \          </a>\n        </li>\n\n        <li class=\"nav-item\">\n      \
+        \    <a class=\"nav-link\" href=\"/fedora-hubs/commits/develop\">\n      \
+        \        <span class=\"oi hidden-md-up\" data-glyph=\"spreadsheet\">\n   \
+        \           </span><span class=\"hidden-sm-down\">Commits</span>\n       \
+        \     </a>\n        </li>\n\n        <li class=\"nav-item\">\n          <a\
+        \ class=\"nav-link\" href=\"/fedora-hubs/tree/develop\">\n              <span\
+        \ class=\"oi hidden-md-up\" data-glyph=\"file\"></span>\n              <span\
+        \ class=\"hidden-sm-down\">Files</span>\n          </a>\n        </li>\n\n\
+        \        <li class=\"nav-item\">\n          <a class=\"nav-link\" href=\"\
+        /fedora-hubs/releases\">\n              <span class=\"oi hidden-md-up\" data-glyph=\"\
+        box\"></span>\n              <span class=\"hidden-sm-down\">Releases</span>\n\
+        \          </a>\n        </li>\n\n        <li class=\"nav-item\">\n      \
+        \      <a class=\"nav-link\" href=\"/fedora-hubs/issues\">\n             \
+        \   <span class=\"oi hidden-md-up\" data-glyph=\"warning\"></span>\n     \
+        \           <span class=\"hidden-sm-down\">Issues&nbsp;</span>\n         \
+        \       <span class=\"label label-default label-pill hidden-sm-down\">\n \
+        \                 111\n                </span>\n            </a>\n       \
+        \ </li>\n\n        <li class=\"nav-item\">\n          <a class=\"nav-link\"\
+        \ href=\"/fedora-hubs/pull-requests\">\n              <span class=\"oi hidden-md-up\"\
+        \ data-glyph=\"task\"></span>\n              <span class=\"hidden-sm-down\"\
+        >Pull Requests&nbsp;</span>\n              <span class=\"label label-default\
+        \ label-pill hidden-sm-down\">\n                3\n              </span>\n\
+        \          </a>\n        </li>\n\n        <li class=\"nav-item\">\n      \
+        \    <a class=\"nav-link\" href=\"/fedora-hubs/forks\">\n              <span\
+        \ class=\"oi hidden-md-up\" data-glyph=\"fork\"></span>\n              <span\
+        \ class=\"hidden-sm-down\">Forks&nbsp;</span>\n              <span class=\"\
+        hidden-sm-down label label-default label-pill\">\n                50\n   \
+        \           </span>\n            </a>\n        </li>\n\n\n    </ul>\n  </div>\n\
+        </div>\n\n<div class=\"container p-t-3\">\n  <div class=\"row\">\n       \
+        \ <div class=\"col-md-8\">\n            <section class=\"readme\">\n     \
+        \           <div class=\"document\">\n<h1>Fedora Hubs</h1>\n<p>Fedora Hubs\
+        \ will provide a communication and collaboration center for Fedora\ncontributors\
+        \ of all types. The idea is that contributors will be able to visit\nHubs\
+        \ to check on their involvements across Fedora, discover new places that they\n\
+        can contribute, and more.</p>\n<p>Hubs is currently under development, and\
+        \ you can see the progress on the\nDevelopment instance here: <a href=\"https://hubs-dev.fedorainfracloud.org/\"\
+        >https://hubs-dev.fedorainfracloud.org/</a></p>\n<div class=\"section\">\n\
+        <h1>Get Involved</h1>\n<p>Visit our <a href=\"https://lists.fedoraproject.org/archives/list/hubs-devel@lists.fedoraproject.org\"\
+        >mailing list</a>\nand join us in the <code><span class=\"pre\">#fedora-hubs</span></code>\
+        \ IRC channel on irc.freenode.net. Meetings are held\nweekly in <code><span\
+        \ class=\"pre\">#fedora-hubs</span></code> at 14:00UTC and the minutes for\
+        \ every meeting are\n<a href=\"https://meetbot.fedoraproject.org/sresults/?group_id=fedora-hubs&amp;type=team\"\
+        >archived</a>.\nIn the meetings we review our statuses from the preceding\
+        \ week and do ticket triage, too.</p>\n<p>For a more detailed overview of\
+        \ what Fedora Hubs is, see the\n<a href=\"https://docs.pagure.org/fedora-hubs/overview.html\"\
+        >documentation</a>.</p>\n<p>To set up a development environment and start\
+        \ contributing, check out\nthe <a href=\"https://docs.pagure.org/fedora-hubs/dev-guide.html\"\
+        >development guide</a>.</p>\n</div>\n</div>\n\n            </section>\n  \
+        \      </div>\n      <div class=\"col-md-4\">\n        <div class=\"card\"\
+        >\n          <div class=\"card-block\">\n            <h5><strong>Owners</strong></h5>\n\
+        \            <div class=\"m-b-2\">\n              <div>\n                <a\
+        \ href=\"/user/decause\">\n                  <img class=\"avatar circle\"\
+        \ src=\"https://seccdn.libravatar.org/avatar/2107fccec2d30c09bcc3f4141388b10aabf16b2a9664f16cdf7227295f28e89b?s=20&d=retro\"\
+        />\n                  Remy DeCausemaker (decause)  -  creator\n          \
+        \      </a>\n              </div>\n              <div>\n                <a\
+        \ href=\"/user/mrichard\">\n                  <img class=\"avatar circle\"\
+        \ src=\"https://seccdn.libravatar.org/avatar/d64b6dc2a878d19f600cb711e02d8547fc94589f8633452f84da1cb961d2b892?s=20&d=retro\"\
+        />\n                  Meghan Richardson (mrichard)\n                </a>\n\
+        \              </div>\n              <div>\n                <a href=\"/user/duffy\"\
+        >\n                  <img class=\"avatar circle\" src=\"https://seccdn.libravatar.org/avatar/e4e83ac110d58771f0c0125651a1ab585e9f72715dc76bd4af54e0102e96f171?s=20&d=retro\"\
+        />\n                  M\xE1ir\xEDn Duffy (duffy)\n                </a>\n \
+        \             </div>\n              <div>\n                <a href=\"/user/lmacken\"\
+        >\n                  <img class=\"avatar circle\" src=\"https://seccdn.libravatar.org/avatar/d433d26a9f50eb87d94b0473472202aa7cf7952700ae82fc5f9750adc0aad37e?s=20&d=retro\"\
+        />\n                  Luke Macken (lmacken)\n                </a>\n      \
+        \        </div>\n              <div>\n                <a href=\"/user/nyazdani\"\
+        >\n                  <img class=\"avatar circle\" src=\"https://seccdn.libravatar.org/avatar/40c9ac361c6cf560171f6bfb99eef9c6849bf8156e2faa15b067e4c4d092246b?s=20&d=retro\"\
+        />\n                  Nathaniel Yazdani (nyazdani)\n                </a>\n\
+        \              </div>\n              <div>\n                <a href=\"/user/bee2502\"\
+        >\n                  <img class=\"avatar circle\" src=\"https://seccdn.libravatar.org/avatar/0b4ce1166336c24dae92f4ece34d4b6a2c7218dd85088967e2f12c6e7b09d5ce?s=20&d=retro\"\
+        />\n                  Bhagyashree Padalkar (bee2502)\n                </a>\n\
+        \              </div>\n              <div>\n                <a href=\"/user/devyani7\"\
+        >\n                  <img class=\"avatar circle\" src=\"https://seccdn.libravatar.org/avatar/cbfbb8a5d78cfc3a595d65dd26074e5b5799bb2b585311dcc0dd18230e2f5649?s=20&d=retro\"\
+        />\n                  Devyani Kota (devyani7)\n                </a>\n    \
+        \          </div>\n              <div>\n                <a href=\"/user/dhrish20\"\
+        >\n                  <img class=\"avatar circle\" src=\"https://seccdn.libravatar.org/avatar/156c08ff565412423d5bdb7a1d46e9ea0a3f0cf8f9b51b4f6cd0c6da56a72da9?s=20&d=retro\"\
+        />\n                  Dhriti Shikhar (dhrish20)\n                </a>\n  \
+        \            </div>\n              <div>\n                <a href=\"/user/jflory7\"\
+        >\n                  <img class=\"avatar circle\" src=\"https://seccdn.libravatar.org/avatar/bc8fd31501030af99c3f31ca8a1f4ee205a1d0035b487d09a497a194b8777c70?s=20&d=retro\"\
+        />\n                  Justin W. Flory (jflory7)\n                </a>\n  \
+        \            </div>\n              <div>\n                <a href=\"/user/pingou\"\
+        >\n                  <img class=\"avatar circle\" src=\"https://seccdn.libravatar.org/avatar/b3ee7bb4de70b6522c2478df3b4cd6322b5ec5d62ac7ceb1128e3d4ff42f6928?s=20&d=retro\"\
+        />\n                  Pierre-YvesChibon (pingou)\n                </a>\n \
+        \             </div>\n              <div>\n                <a href=\"/user/ryanlerch\"\
+        >\n                  <img class=\"avatar circle\" src=\"https://seccdn.libravatar.org/avatar/de5bf8d06663adb3bb1b8d49ccab259828fad7dddeb233b073d0c447d79b4c14?s=20&d=retro\"\
+        />\n                  Ryan Lerch (ryanlerch)\n                </a>\n     \
+        \         </div>\n              <div>\n                <a href=\"/user/skrzepto\"\
+        >\n                  <img class=\"avatar circle\" src=\"https://seccdn.libravatar.org/avatar/55ffbcbe7ef5ef02b58c2082b79aa1dc23794da806e19333d4dbb994c4093b3d?s=20&d=retro\"\
+        />\n                  Szymon Mucha (skrzepto)\n                </a>\n    \
+        \          </div>\n              <div>\n                <a href=\"/user/sayanchowdhury\"\
+        >\n                  <img class=\"avatar circle\" src=\"https://seccdn.libravatar.org/avatar/4771836b6b430740e853f097f7121782109560ec6099e72ffc923ed17f9f88bd?s=20&d=retro\"\
+        />\n                  Sayan Chowdhury (sayanchowdhury)\n                </a>\n\
+        \              </div>\n              <div>\n                <a href=\"/user/bkorren\"\
+        >\n                  <img class=\"avatar circle\" src=\"https://seccdn.libravatar.org/avatar/632177fa944babf9d34ebdc5fb82a4b2ea3ca7c1da7ef9657ebd6f3f48e3c094?s=20&d=retro\"\
+        />\n                  bkorren (bkorren)\n                </a>\n          \
+        \    </div>\n              <div>\n                <a href=\"/user/atelic\"\
+        >\n                  <img class=\"avatar circle\" src=\"https://seccdn.libravatar.org/avatar/72118562545c3cad698b51ca813fd0149dd19f63d7dceec161d447b834b03a45?s=20&d=retro\"\
+        />\n                  Eric Barbour (atelic)\n                </a>\n      \
+        \        </div>\n              <div>\n                <a href=\"/user/wispfox\"\
+        >\n                  <img class=\"avatar circle\" src=\"https://seccdn.libravatar.org/avatar/b5f1b3792dc945fba3b616b489aa688b91577f186283427b4f08dd9dcbe53db7?s=20&d=retro\"\
+        />\n                  Suzanne Hillman (wispfox)\n                </a>\n  \
+        \            </div>\n              <div>\n                <a href=\"/user/jcline\"\
+        >\n                  <img class=\"avatar circle\" src=\"https://seccdn.libravatar.org/avatar/1a108f46a960aa35efcabd0b779cd59b8c3aba2927213fe63373921e1aa3fac4?s=20&d=retro\"\
+        />\n                  Jeremy Cline (jcline)\n                </a>\n      \
+        \        </div>\n              <div>\n                <a href=\"/user/abompard\"\
+        >\n                  <img class=\"avatar circle\" src=\"https://seccdn.libravatar.org/avatar/224e9ad3084cb9f442f423b7910701377be7a018408a4f8b22a09d94c89af46f?s=20&d=retro\"\
+        />\n                  Aurelien Bompard (abompard)\n                </a>\n\
+        \              </div>\n            </div>\n            <h5><strong>Branches</strong></h5>\n\
+        \            <div class=\"m-b-2\">\n              <div id=\"branch-develop\"\
+        \ class=\"repoinfo-branchlistitem row\">\n                <div class=\"branch_name\
+        \ col-md-10\">\n                  <span class=\"oi text-muted\" data-glyph=\"\
+        random\"\n                    title=\"Default branch\"></span>\n         \
+        \         <strong title=\"Currently viewing branch develop\" data-toggle=\"\
+        tooltip\">develop</strong>\n                </div>\n                <div class=\"\
+        branch_del col-md-2\">\n                  <span class=\"oi text-muted\" data-glyph=\"\
+        star\"\n                    title=\"Default branch\"></span>\n           \
+        \     </div>\n              </div>\n\n              <div id=\"branch-feature__bugzilla-links\"\
+        \ class=\"repoinfo-branchlistitem row\">\n                <div class=\"branch_name\
+        \ col-md-8\">\n                  <span class=\"oi text-muted\" data-glyph=\"\
+        random\"></span>\n                  <a class=\"\" href=\"/fedora-hubs/branch/feature/bugzilla-links\"\
+        \n                    title=\"feature/bugzilla-links\" data-toggle=\"tooltip\"\
+        >feature/bugzilla-links\n                  </a>\n\n                </div>\n\
+        \                <div class=\"branch_del col-md-4\">\n                </div>\n\
+        \              </div>\n              <div id=\"branch-fix_fedmsgstats\" class=\"\
+        repoinfo-branchlistitem row\">\n                <div class=\"branch_name col-md-8\"\
+        >\n                  <span class=\"oi text-muted\" data-glyph=\"random\"></span>\n\
+        \                  <a class=\"\" href=\"/fedora-hubs/branch/fix_fedmsgstats\"\
+        \n                    title=\"fix_fedmsgstats\" data-toggle=\"tooltip\">fix_fedmsgstats\n\
+        \                  </a>\n\n                </div>\n                <div class=\"\
+        branch_del col-md-4\">\n                </div>\n              </div>\n   \
+        \           <div id=\"branch-jenkins\" class=\"repoinfo-branchlistitem row\"\
+        >\n                <div class=\"branch_name col-md-8\">\n                \
+        \  <span class=\"oi text-muted\" data-glyph=\"random\"></span>\n         \
+        \         <a class=\"\" href=\"/fedora-hubs/branch/jenkins\"\n           \
+        \         title=\"jenkins\" data-toggle=\"tooltip\">jenkins\n            \
+        \      </a>\n\n                </div>\n                <div class=\"branch_del\
+        \ col-md-4\">\n                </div>\n              </div>\n            \
+        \  <div id=\"branch-master\" class=\"repoinfo-branchlistitem row\">\n    \
+        \            <div class=\"branch_name col-md-8\">\n                  <span\
+        \ class=\"oi text-muted\" data-glyph=\"random\"></span>\n                \
+        \  <a class=\"\" href=\"/fedora-hubs/branch/master\"\n                   \
+        \ title=\"master\" data-toggle=\"tooltip\">master\n                  </a>\n\
+        \n                </div>\n                <div class=\"branch_del col-md-4\"\
+        >\n                </div>\n              </div>\n              <div id=\"\
+        branch-unittest\" class=\"repoinfo-branchlistitem row\">\n               \
+        \ <div class=\"branch_name col-md-8\">\n                  <span class=\"oi\
+        \ text-muted\" data-glyph=\"random\"></span>\n                  <a class=\"\
+        \" href=\"/fedora-hubs/branch/unittest\"\n                    title=\"unittest\"\
+        \ data-toggle=\"tooltip\">unittest\n                  </a>\n\n           \
+        \     </div>\n                <div class=\"branch_del col-md-4\">\n      \
+        \          </div>\n              </div>\n            </div>\n            <h5><strong>Source\
+        \ GIT URLs</strong>                  <span class=\"pull-xs-right\"><a data-toggle=\"\
+        collapse\" href=\"#moregiturls\"\n                  aria-expanded=\"false\"\
+        \ aria-controls=\"moregiturls\"\n                  id=\"more_gits\">more</a></span></h5>\n\
+        \            <div>\n              <div class=\"form-group\">\n           \
+        \     <div class=\"input-group input-group-sm\">\n                  <div class=\"\
+        input-group-addon\">SSH</div>\n                  <input class=\"form-control\"\
+        \ type=\"text\" value=\"ssh://git@pagure.io/fedora-hubs.git\" readonly>\n\
+        \                </div>\n              </div>\n              <div class=\"\
+        form-group\">\n                <div class=\"input-group input-group-sm\">\n\
+        \                  <div class=\"input-group-addon\">GIT</div>\n          \
+        \        <input class=\"form-control\" type=\"text\" value=\"https://pagure.io/fedora-hubs.git\"\
+        \ readonly>\n                </div>\n              </div>\n              <div\
+        \ class=\"collapse\" id=\"moregiturls\">\n                  <h5><strong>Docs\
+        \ GIT URLs</strong></h5>\n                  <div class=\"form-group\">\n \
+        \                   <div class=\"input-group input-group-sm\">\n         \
+        \             <div class=\"input-group-addon\">GIT</div>\n               \
+        \       <input class=\"form-control\" type=\"text\" value=\"https://pagure.io/docs/fedora-hubs.git\"\
+        \ readonly>\n                    </div>\n                  </div>\n      \
+        \        </div>\n            </div>\n          </div>\n          <div class=\"\
+        repo_date\" title=\"2015-06-04 17:27:48.074785\">\n              created 2\
+        \ years ago\n          </div>\n        </div>\n\n          <div class=\"card\"\
+        >\n            <div class=\"card-header\">\n              <strong>Recent Commits\
+        \ in\n                <span class=\"pr-toplabel\">\n                  <span\
+        \ class=\"oi\" data-glyph=\"random\"></span>\n                  develop\n\
+        \                </span>\n              </strong>\n            </div>\n  \
+        \          <div class=\"card-block p-a-0\">\n              <div class=\"list-group\
+        \ list-group-flush\">\n                  <a href=\"/fedora-hubs/c/71893f00e2afa9a2b8c3c2e2b417effabfa8a97e\"\
+        \ class=\"list-group-item\">\n                    <div class=\"commitdate\"\
+        \ title=\"Feb 10 2017 15:10:50\">\n                      <small>\n       \
+        \                 <strong>\n                          <img class=\"avatar\
+        \ circle\" src=\"https://seccdn.libravatar.org/avatar/224e9ad3084cb9f442f423b7910701377be7a018408a4f8b22a09d94c89af46f?s=20&d=retro\"\
+        />\n                          Aur\xE9lien Bompard\n                      \
+        \  </strong>\n                        commited 3 days ago\n              \
+        \        </small>\n                    </div>\n                    <div><small>\n\
+        \                      Sort the widget registry by name\n                \
+        \    </small></div>\n                  </a>\n                  <a href=\"\
+        /fedora-hubs/c/d6eb8815e9c4e7d6e60a924113b13095c5ccbe7e\" class=\"list-group-item\"\
+        >\n                    <div class=\"commitdate\" title=\"Feb 10 2017 13:56:13\"\
+        >\n                      <small>\n                        <strong>\n     \
+        \                     <img class=\"avatar circle\" src=\"https://seccdn.libravatar.org/avatar/224e9ad3084cb9f442f423b7910701377be7a018408a4f8b22a09d94c89af46f?s=20&d=retro\"\
+        />\n                          Aur\xE9lien Bompard\n                      \
+        \  </strong>\n                        commited 3 days ago\n              \
+        \        </small>\n                    </div>\n                    <div><small>\n\
+        \                      Fix the help text in the widgets config template\n\
+        \                    </small></div>\n                  </a>\n            \
+        \      <a href=\"/fedora-hubs/c/5e3de90c7d948bb82e4651e9d5b73a63472fa9e9\"\
+        \ class=\"list-group-item\">\n                    <div class=\"commitdate\"\
+        \ title=\"Feb 10 2017 10:27:24\">\n                      <small>\n       \
+        \                 <strong>\n                          <img class=\"avatar\
+        \ circle\" src=\"https://seccdn.libravatar.org/avatar/224e9ad3084cb9f442f423b7910701377be7a018408a4f8b22a09d94c89af46f?s=20&d=retro\"\
+        />\n                          Aur\xE9lien Bompard\n                      \
+        \  </strong>\n                        commited 4 days ago\n              \
+        \        </small>\n                    </div>\n                    <div><small>\n\
+        \                      Make CachedFunction.should_invalidate() abstract\n\
+        \                    </small></div>\n                  </a>\n            \
+        \  </div>\n              </div>\n            </div>\n          </div>\n  \
+        \    </div>\n    </div>\n\n\n</div>\n    </div>\n\n    <div class=\"footer\
+        \ p-t-1 p-b-1\">\n        <div class=\"container\">\n            <p class=\"\
+        text-muted credit\">\n         Copyright &copy; 2014-2017 Red Hat\n      \
+        \    <a href=\"https://pagure.io/pagure\">pagure</a> &mdash;\n          2.12.1\
+        \ &mdash; <a href=\"https://docs.pagure.org/pagure/usage.html\">Documentation</a>\n\
+        \            </p>\n            <p><a href=\"/ssh_info\">SSH Hostkey/Fingerprint</a></p>\n\
+        \        </div>\n    </div>\n\n    <script type=\"text/javascript\"\n    \
+        \    src=\"/static/jquery.min.js\">\n    </script>\n    <script type=\"text/javascript\"\
+        \n        src=\"/static/jquery-ui.min.js\">\n    </script>\n    <script type=\"\
+        text/javascript\"\n        src=\"https://apps.fedoraproject.org/global/fedora-bootstrap-1.0.1/fedora-bootstrap.js\"\
+        >\n    </script>\n    <script type=\"text/javascript\">\n$('[data-toggle=\"\
+        tooltip\"]').tooltip({placement : 'bottom'});\n    </script>\n\n<script type=\"\
+        text/javascript\">\n$(document).ready(function() {\n  $(\".watch-menu a\"\
+        ).click(function(){\n    var selectedValue = $(this).attr('id');\n    var\
+        \ action = $(\"#watch_project\").attr('action');\n      if (selectedValue\
+        \ != \"unwatch_button\") {\n        action = action.replace('/settings/0',\
+        \ '/settings/1');\n        $('#watch_project').attr('action', action);\n \
+        \     }\n      $('#watch_project').submit();\n\n  });\n});\n</script>\n\n\
+        <script type=\"text/javascript\">\n$(document).ready(function() {\n    $(\"\
+        .extra_gits\").hide();\n});\n\n$(function() {\n  $( \"#more_gits\" ).click(function()\
+        \ {\n      if ($( \"#more_gits\" ).html() == 'more') {\n        $( \"#more_gits\"\
+        \ ).html('less');\n      } else {\n        $( \"#more_gits\" ).html('more');\n\
+        \      }\n  });\n\n});\n</script>\n\n\n</body>\n</html>"}
+    headers:
+      connection: [Keep-Alive]
+      content-length: ['21185']
+      content-type: [text/html; charset=utf-8]
+      date: ['Tue, 14 Feb 2017 10:48:02 GMT']
+      keep-alive: ['timeout=5, max=100']
+      server: [Apache/2.4.6 (Red Hat Enterprise Linux) OpenSSL/1.0.1e-fips mod_wsgi/3.4
+          Python/2.7.5]
+      set-cookie: ['pagure=eyJfcGVybWFuZW50Ijp0cnVlLCJjc3JmIjp7IiBiIjoiTTJSallqTmlaak16T1ROaE4yWTNOekZpWkdNeFptRTVZek13Wm1FM01ETTBaV1E0WlRFMU1BPT0ifX0.C4Rx4g.oLbGmDy2SdBOneLnLMwKWvCQ5WY;
+          Expires=Fri, 17-Mar-2017 10:48:02 GMT; Secure; HttpOnly; Path=/']
+      strict-transport-security: [max-age=15768000; includeSubDomains; preload]
+    status: {code: 200, message: OK}
+- request:
+    body: null
+    headers:
+      Accept: ['*/*']
+      Accept-Encoding: ['gzip, deflate']
+      Connection: [keep-alive]
+      User-Agent: [python-requests/2.13.0]
+    method: GET
+    uri: https://pagure.io/something-that-does-not-exist
+  response:
+    body: {string: !!python/unicode "<!DOCTYPE html>\n<html lang='en'>\n<head>\n \
+        \   <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"\
+        />\n    <title>Page not found :'( - Pagure</title>\n    <link rel=\"shortcut\
+        \ icon\" type=\"image/vnd.microsoft.icon\"\n        href=\"/static/favicon.ico\"\
+        />\n    <link href=\"https://apps.fedoraproject.org/global/fedora-bootstrap-1.0.1/fedora-bootstrap.css\"\
+        \n        type=\"text/css\" rel=\"stylesheet\" />\n    <link href=\"/static/pagure.css\"\
+        \n        type=\"text/css\" rel=\"stylesheet\" />\n    <link href=\"/static/open-iconic/css/open-iconic.min.css\"\
+        \n        type=\"text/css\" rel=\"stylesheet\" />\n    <link href=\"/static/fonts/fonts.css\"\
+        \n        rel=\"stylesheet\" type=\"text/css\" />\n    <link href=\"/static/hack_fonts/css/hack-extended.min.css\"\
+        \n        type=\"text/css\" rel=\"stylesheet\" />\n  </head>\n  <body id=\"\
+        error\">\n  <!-- start masthead -->\n    <div class=\"masthead\">\n      <div\
+        \ class=\"container\">\n        <div class=\"row\">\n          <div class=\"\
+        col-sm-3\">\n            <a href=\"/\">\n              <img height=40px src=\"\
+        /static/pagure-logo.png\"\n                alt=\"pagure Logo\" id=\"pagureLogo\"\
+        />\n            </a>\n          </div>\n          <div class=\"col-sm-9\"\
+        >\n            <div class=\"row\">\n\n  <nav class=\"navbar navbar-light p-t-0\
+        \ p-b-0\">\n      <div class=\"container\">\n        <ul class=\"nav navbar-nav\
+        \ nav-underline pull-xs-right\">\n              <li class=\"nav-item p-l-1\"\
+        >\n                <a class=\"nav-link btn btn-primary\" href=\"/login/?next=https://pagure.io/something-that-does-not-exist\"\
+        >Log In</a>\n              </li>\n        </ul>\n      </div>\n    </nav>\n\
+        \n            </div>\n          </div>\n        </div>\n      </div>\n   \
+        \ </div><!-- close masthead-->\n\n    <div class=\"bodycontent p-b-3\">\n\n\
+        \n<div class=\"container p-t-3\">\n  <div class=\"row\">\n    <div class=\"\
+        col-md-8\">\n      <h2>Page not found (404)</h2>\n      <p>With the message:</p>\n\
+        \      <div class=\"card-block\">\n      <p>Project not found</p>\n      </div>\n\
+        \      <p>You have either entered a bad URL or the page has moved, removed,\
+        \ or otherwise rendered unavailable.<br/>\n      Please use the main navigation\
+        \ menu to get (re)started.</p>\n    </div>\n  </div>\n</div>\n    </div>\n\
+        \n    <div class=\"footer p-t-1 p-b-1\">\n        <div class=\"container\"\
+        >\n            <p class=\"text-muted credit\">\n         Copyright &copy;\
+        \ 2014-2017 Red Hat\n          <a href=\"https://pagure.io/pagure\">pagure</a>\
+        \ &mdash;\n          2.12.1 &mdash; <a href=\"https://docs.pagure.org/pagure/usage.html\"\
+        >Documentation</a>\n            </p>\n            <p><a href=\"/ssh_info\"\
+        >SSH Hostkey/Fingerprint</a></p>\n        </div>\n    </div>\n\n    <script\
+        \ type=\"text/javascript\"\n        src=\"/static/jquery.min.js\">\n    </script>\n\
+        \    <script type=\"text/javascript\"\n        src=\"/static/jquery-ui.min.js\"\
+        >\n    </script>\n    <script type=\"text/javascript\"\n        src=\"https://apps.fedoraproject.org/global/fedora-bootstrap-1.0.1/fedora-bootstrap.js\"\
+        >\n    </script>\n    <script type=\"text/javascript\">\n$('[data-toggle=\"\
+        tooltip\"]').tooltip({placement : 'bottom'});\n    </script>\n\n\n</body>\n\
+        </html>"}
+    headers:
+      connection: [Keep-Alive]
+      content-length: ['3009']
+      content-type: [text/html; charset=utf-8]
+      date: ['Tue, 14 Feb 2017 10:48:03 GMT']
+      keep-alive: ['timeout=5, max=100']
+      server: [Apache/2.4.6 (Red Hat Enterprise Linux) OpenSSL/1.0.1e-fips mod_wsgi/3.4
+          Python/2.7.5]
+      set-cookie: ['pagure=eyJfcGVybWFuZW50Ijp0cnVlfQ.C4Rx4w.okkFK2vKErtBTg2N2mPN4XPMTVc;
+          Expires=Fri, 17-Mar-2017 10:48:03 GMT; Secure; HttpOnly; Path=/']
+      strict-transport-security: [max-age=15768000; includeSubDomains; preload]
+    status: {code: 404, message: NOT FOUND}
+version: 1
